package projavafx;
	
import javafx.application.Application;
import javafx.event.Event;
import javafx.event.EventHandler;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.StackPane;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.util.Duration;


public class AudioPortFXJava8 extends Application {
	private final StackPane root = new StackPane();
	private final Rectangle background = new Rectangle(300, 250);
	private final Button play_btn = new Button();
	private final Button stop_btn = new Button();
	private MediaPlayer mp;
	
    @SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public void start(Stage primaryStage) {
	    background.setFill(Color.ORANGE);
	    
	    play_btn.setStyle("-fx-background-color: #4d90cd; -fx-background-radius: 0; -fx-text-fill: white;");
	    play_btn.setTranslateY(-40);
	    play_btn.setText("Play");
	    play_btn.setOnAction(new EventHandler() {
			public void handle(Event arg0) {
				playAudio();
			}
	    });
	    
	    stop_btn.setStyle("-fx-background-color: #4d90cd; -fx-background-radius: 0; -fx-text-fill: white;");
	    stop_btn.setTranslateY(30);
	    stop_btn.setText("Stop");
	    stop_btn.setOnAction(new EventHandler() {
			public void handle(Event arg0) {
				stopAudio();
			}
	    });
 
	    root.getChildren().addAll(background, play_btn, stop_btn);
	     
	    Scene scene = new Scene(root, 300, 250);
	     
	    primaryStage.setTitle("JavaFX Audio Porting Java 8");
	    primaryStage.setScene(scene);
	    primaryStage.show();

	    Media media = new Media(getClass().getResource("/test.wav").toString());
		mp = new MediaPlayer(media);
    }
    
    private void playAudio() {
    	mp.seek(new Duration(0.0));
    	mp.play();
//    	background.setFill(Color.GREEN);
    }
    
    private void stopAudio() {
    	mp.stop();
//    	background.setFill(Color.RED);
    }
 
    public static void main(String[] args) {
    	launch(args);
    }
}
