package org.cleflore.kebug ;
import org.cleflore.kebug.s.PlatformService ;

import javafx.application.Application;

import javafx.event.EventHandler;
import javafx.geometry.Rectangle2D;

import javafx.scene.control.Button;
import javafx.scene.control.Label;

import javafx.scene.Scene;
import javafx.scene.input.KeyEvent ;
import javafx.scene.input.MouseEvent ;
import javafx.scene.layout.HBox ;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color ;
import javafx.scene.shape.Rectangle ;
import javafx.scene.web.WebEngine ;
import javafx.scene.web.WebView ;

import javafx.stage.Screen;
import javafx.stage.Stage;

public class Main extends Application {
	private boolean toggle = false ;
	private static Rectangle leftSurface  = new Rectangle() ;
	private static WebView	 rightSurface = new WebView() ;
	private static HBox		 mainLayout	= new HBox() ;
	private static Label	 keyboard	= new Label("KeyboardLabel") ;

	final EventHandler<KeyEvent> sceneEventHandler =
								 new EventHandler<KeyEvent>() {
		public void handle(final KeyEvent keyEvent) {
			if (toggle = !toggle) mainLayout.toFront() ;
			else				  keyboard.toFront() ;
			keyEvent.consume() ;
		}
	} ;

	final EventHandler<MouseEvent> sceneMouseHandler =
								 new EventHandler<MouseEvent>() {
		public void handle(final  MouseEvent mouseEvent) {
			if (toggle = !toggle) mainLayout.toFront() ;
			else				  keyboard.toFront() ;
			mouseEvent.consume() ;
		}
	} ;

    @Override
    public void start(Stage stage) {
		PlatformService.getInstance() ;
        Rectangle2D bounds = Screen.getPrimary().getVisualBounds();
        double width  = bounds.getWidth()  ;
        double height = bounds.getHeight() ;

        // ANDROID STRANGE BEHAVIOUR BUG:: divide each of width & height by 2
        // width /= 2 ; height /= 2 ;

		leftSurface.setHeight(height * 0.9) ;
		leftSurface.setWidth(width   * 0.5) ;
		leftSurface.setFill(Color.YELLOW) ;

		rightSurface.setPrefSize(width * 0.4, height * 0.9) ;
		rightSurface.setMaxSize(width * 0.4, height * 0.9) ;
		rightSurface.getEngine().loadContent(
			"<html><body>webview here</body></html>") ;

        mainLayout.getChildren().setAll(leftSurface, rightSurface) ;

        Scene scene = new Scene(new StackPane(mainLayout, keyboard),
								width, height) ;
		scene.setOnKeyPressed(sceneEventHandler) ;
	 	scene.setOnMousePressed(sceneMouseHandler) ;

        stage.setScene(scene);
        stage.show();
    }
}
