package com.sample.controllers;

import java.net.URL;
import java.util.ArrayList;
import java.util.ResourceBundle;

import javafx.beans.property.IntegerProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TabPane;
import javafx.scene.control.ToolBar;
import javafx.scene.effect.BoxBlur;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.SwipeEvent;
import javafx.scene.layout.Background;
import javafx.scene.layout.BackgroundFill;
import javafx.scene.layout.CornerRadii;
import javafx.scene.layout.GridPane;
import javafx.scene.paint.Color;
import javafx.scene.paint.Paint;
import javafxports.android.FXActivity;
import android.content.Context;
import android.content.pm.PackageManager.NameNotFoundException;
import android.util.Log;

import com.sample.pack.Main;

public final class CtrMain extends Controller {

	private static final String TAG = "ControllerMain";

	public static final int STATE_READING_TRANSITION_START = 10;
	public static final int STATE_READING_TRANSITION_STOP = 11;

	public static final int GEN_STATE_UNKNOWN = -1;
	public static final int GEN_STATE_OFF = 0;
	public static final int GEN_STATE_PITCH = 1;
	public static final int GEN_STATE_ON = 2;

	private static CtrMain instance;

	@FXML private GridPane gridPane;
	@FXML private TabPane tabPane;

	@FXML private ToolBar toolBar;

	@FXML private Button btnConnection;
	@FXML private Button btnReading;

	@FXML private Label lblAppInfo;
	@FXML private Label lblDeviceState;
	@FXML private Label lblGenState;

	// ==========================================================================

	public CtrMain() {

		instance = this;
	}

	// ==========================================================================

	public static CtrMain getInstance() {

		return instance;
	}

	// ==========================================================================

	public GridPane getRootNode() {

		return gridPane;
	}

	// ==========================================================================

	@Override
	public void close() {

		Main.runAndWait(new Runnable() {

			@Override
			public void run() {

				CtrMain.getInstance().setBlur(false);
				Main.getInstance().getMainStage().hide();
			}
		});
	}

	// ==========================================================================

	public void setBlur(final boolean blur) {

		if (blur) {

			// toolBar.setEffect(new BoxBlur(8, 8, 3));
			tabPane.setEffect(new BoxBlur(8, 8, 3));
		}
		else {

			// toolBar.setEffect(null);
			tabPane.setEffect(null);
		}
	}

	// ==========================================================================

	@Override
	public void initialize(final URL location, final ResourceBundle resources) {

		super.initialize(location, resources);

		tabPane.getSelectionModel().select(3);
	}

	// ==========================================================================
}
