package uk.vanleersum.smuggler.gui;

import javafx.application.Platform;
import javafx.geometry.Pos;
import javafx.scene.Node;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.ScrollPane.ScrollBarPolicy;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.StackPane;

public class GuiRoot extends StackPane {

	private final GridPane coverPane = new GridPane();

	public GuiRoot() {
		super();
		this.coverPane.setAlignment(Pos.CENTER);
		this.coverPane.setStyle("-fx-background-color: #f0ffffc0;");
		this.coverPane.setMaxSize(Double.MAX_VALUE, Double.MAX_VALUE);
	}

	public final void clear() {
		Platform.runLater(() -> {
			this.getChildren().remove(this.coverPane);
			this.coverPane.getChildren().clear();
		});
	}


	public final void presentNode(final Node node) {
		this.getChildren().remove(this.coverPane);
		this.coverPane.getChildren().clear();
		this.coverPane.getChildren().add(node);
		this.getChildren().add(this.coverPane);
	}



	public final void setChild(final Node child, final boolean inScrollPane) {
		this.getChildren().clear();
		if (inScrollPane) {
			final ScrollPane scrollPane = new ScrollPane(child);
			scrollPane.setHbarPolicy(ScrollBarPolicy.NEVER);
			scrollPane.setVbarPolicy(ScrollBarPolicy.AS_NEEDED);
			scrollPane.setFitToWidth(true);
			this.getChildren().add(scrollPane);
		} else {
			this.getChildren().add(child);
		}
	}


}
