package uk.vanleersum.smuggler.gui;

import java.io.File;

import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.Priority;
import javafx.scene.layout.VBox;

public class SmugglerPane extends VBox {
	//@formatter:off
	private static final String test = "-fx-background-color:"
        + "#a6b5c9,"
        + "linear-gradient(#303842 0%, #3e5577 20%, #375074 100%),"
        + "linear-gradient(#768aa5 0%, #849cbb 5%, #5877a2 50%, #486a9a 51%, #4a6c9b 100%);"
    + "-fx-background-insets: 0 -1 -1 0,1,1;"
    + "-fx-background-radius: 15,15,14;"
    + "-fx-effect: dropshadow( three-pass-box , rgba(0,0,0,0.6) , 15, 0.50 , 10 , 10 );"
    + "-fx-padding: 30;";
    //+ "-fx-text-fill: #242d35;"
    //+ "-fx-font-family: 'Helvetica';"
    //+ "-fx-font-size: 12px;"
    //+ "-fx-text-fill: white;";
	//@formatter:on

	private final GuiRoot guiRoot;

	public SmugglerPane(final GuiRoot guiRoot) {
		super();

		this.setStyle("-fx-background-color: #20889580;\n");

		final Button readButton = new Button("Press me");
		readButton.setStyle(test);
		final double opacity =  0.5;
		readButton.setOpacity(opacity);

		final Button writeButton = new Button("Or press me");
		writeButton.setStyle(test);
		writeButton.setOpacity(opacity);

		this.setAlignment(Pos.CENTER);
		setMargin(readButton, new Insets(20, 0, 40, 0));
		setMargin(writeButton, new Insets(40, 0, 20, 0));
		VBox.setVgrow(readButton, Priority.ALWAYS);
		VBox.setVgrow(writeButton, Priority.ALWAYS);

		this.getChildren().addAll(readButton, writeButton);
		this.guiRoot = guiRoot;

		readButton.setOnAction(a -> this.button1Pressed());
		writeButton.setOnAction(a -> this.button2Pressed());

	}


	private final void button1Pressed() {
		final TextField passwordTextField = new TextField();
		passwordTextField.setPromptText("Try to enter some text");
		final Button cancelButton = new Button("Cancel");
		cancelButton.setPadding(new Insets(10));
		cancelButton.setOnAction(a -> this.guiRoot.clear());
		
		final VBox vbox = new VBox(passwordTextField, cancelButton);
		vbox.setStyle("-fx-background-color: #ffffff;\n");
		vbox.setAlignment(Pos.CENTER);
		this.guiRoot.presentNode(vbox);
	}


	private final void button2Pressed() {
		final TextArea messageTextArea = new TextArea("Try to enter some text");
		messageTextArea.setPrefRowCount(4);

		final TextField passwordTextField = new TextField();
		passwordTextField.setPromptText("Try to enter some text");
		final Button cancelButton = new Button("Cancel");
		cancelButton.setPadding(new Insets(10));
		cancelButton.setOnAction(a -> this.guiRoot.clear());
		
		final VBox vbox = new VBox(messageTextArea, passwordTextField, cancelButton);
		vbox.setStyle("-fx-background-color: #ffffff;\n");
		vbox.setAlignment(Pos.CENTER);
		this.guiRoot.presentNode(vbox);

	}
}
