/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.testandroid.testwebandroid;

import javafx.application.Application;
import static javafx.application.Application.STYLESHEET_CASPIAN;
import static javafx.application.Application.launch;
import static javafx.application.Application.setUserAgentStylesheet;
import javafx.event.EventHandler;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.control.Slider;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.scene.web.WebView;
import javafx.stage.Screen;
import javafx.stage.Stage;
import javafx.stage.WindowEvent;

/**
 *
 * @author Dave B
 */
public class TestWebKit extends Application{

    public static boolean closeDown = false;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        launch(args);
    }
    
    
    @Override
    public void start(final Stage primaryStage) {
        


        
        setUserAgentStylesheet(STYLESHEET_CASPIAN);
        primaryStage.setTitle("WebKitZoom");   
        primaryStage.setOnCloseRequest(new EventHandler<WindowEvent>(){
            public void handle(WindowEvent we){
                System.exit(1);
            }
        });

        Group root = new Group();
        Screen screen = Screen.getPrimary();      
        Scene scene = new Scene(root, screen.getBounds().getWidth(), screen.getBounds().getHeight());

        //create top section with slider - zooms from 0.2 to 1.0;
        StackPane top = new StackPane();
        
        Rectangle r1= new Rectangle();
        r1.widthProperty().bind(scene.widthProperty());
        r1.setHeight(100);
        r1.setFill(Color.WHITE);
        
        Slider s1 = new Slider();
        s1.maxWidthProperty().bind(scene.widthProperty().multiply(0.5));
        s1.setMin(0.2);
        s1.setMax(1.0);
        s1.setValue(1.0);
        
        top.getChildren().addAll(r1,s1);
        
        //webview
        WebView wv = new WebView();
        wv.prefWidthProperty().bind(scene.widthProperty());
        wv.prefHeightProperty().bind(scene.heightProperty().subtract(100));
        
        //webview content zoom is bounds to slider value
        wv.zoomProperty().bind(s1.valueProperty());
        
        
        //add to border pane
        BorderPane bp = new BorderPane();
        bp.setTop(top);
        bp.setCenter(wv);
        
        
        root.getChildren().add(bp);
        
        
        primaryStage.setScene(scene);
        primaryStage.show();
        
        //load bbc
        wv.getEngine().load("http://www.bbc.co.uk");
        
    }
}
