package com.example;
import java.net.URL;
import java.util.ResourceBundle;

import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.TabPane;
import javafx.scene.input.SwipeEvent;
import android.util.Log;

public final class CtrMain implements Initializable {

	@FXML private TabPane tabPane;

	// ==========================================================================

	@Override
	public void initialize(final URL location, final ResourceBundle resources) {

		tabPane.getSelectionModel().select(1);
		tabPane.addEventFilter(SwipeEvent.ANY, onTabPaneSwipe);
	}

	// ==========================================================================

	final EventHandler<SwipeEvent> onTabPaneSwipe = new EventHandler<SwipeEvent>() {

		@Override
		public void handle(final SwipeEvent event) {
			
			Log.d("LOG", event.getEventType() + "");

			if (event.getEventType() == SwipeEvent.SWIPE_LEFT) {

				Log.d("EVENT!", event.getEventType() + "");

				tabPane.getSelectionModel().selectPrevious();
			}

			if (event.getEventType() == SwipeEvent.SWIPE_RIGHT) {

				Log.d("EVENT!", event.getEventType() + "");

				tabPane.getSelectionModel().selectNext();
			}
		}
	};

	// ==========================================================================

	@FXML
	private void setTabLeft(final ActionEvent event) {

		tabPane.getSelectionModel().selectPrevious();
		Log.d("TAB", tabPane.getSelectionModel().getSelectedIndex() + "");
	}

	// ==========================================================================

	@FXML
	private void setTabRight(final ActionEvent event) {

		tabPane.getSelectionModel().selectNext();
		Log.d("TAB", tabPane.getSelectionModel().getSelectedIndex() + "");
	}
}
